#!/usr/bin/python
# Written by: Chuck Short <zulcss@ubuntu.com>
# How out of date are we compared to debian

import urllib
import re
import apt_pkg
import urllib2
from debian.changelog import Changelog


from launchpadlib.launchpad import Launchpad

def get_package_list(lp, pkgs):
	p = re.compile('>([^\s]+)\sin\subuntu')
	team_name = 'ubuntu-server'
	team = lp.people[team_name]
	(f_name, h) = urllib.urlretrieve(\
		"https://bugs.launchpad.net/~%s/+packagebugs" % team.name)

	for l in open(f_name):
		m = p.search(l)
		if m:
			pkgs.append(m.group(1))

	return pkgs

def get_ubuntu_list(lp, package):
	ubuntu = lp.distributions['ubuntu']
	
	primary, partner = ubuntu.archives
	releases = ubuntu.getSeries(name_or_version='natty')
	
	try:
		upload_version = primary.getPublishedSources(
                  exact_match=True, 
                  source_name=package, 
                  pocket="Release", 
                  distro_series=releases)[0].source_package_version
	except:
		upload_version = "n/a"

	return upload_version

def get_debian_package(lp, package):
	debian = lp.distributions['debian']

	primary = debian.main_archive
	releases = debian.getSeries(name_or_version='sid')

	try:
		upload_debian = primary.getPublishedSources(
                  exact_match=True, 
                  source_name=package, 
                  pocket="Release", 
                  distro_series=releases)[0]
	except:
		upload_debian = 0

	return upload_debian

def get_debian_list(lp, package):
  debian_pkg = get_debian_package(lp,package)
  if debian_pkg:
    upload_version = debian_pkg.source_package_version
  else:
    upload_version = 0
  return upload_version

def debian_newer(ubuntu,debian):
  if debian == 0:
    return False
  apt_pkg.InitSystem()
  delta = apt_pkg.VersionCompare(ubuntu, debian)
  if delta < 0:
    return True
  else:
    return False

def getDebianChangelog(srcpkg, version):
    '''
    Return the new changelog entries upto 'version'.
    -- Based on the function from requestsync
    '''
    pkgname = srcpkg.source_package_name
    pkgversion = srcpkg.source_package_version
    component = srcpkg.component_name
    if pkgname.startswith('lib'):
        subdir = 'lib%s' % pkgname[3]
    else:
        subdir = pkgname[0]
    # Strip epoch from version
    if ':' in pkgversion:
        pkgversion = pkgversion[pkgversion.find(':')+1:]

    # Get the debian changelog file from packages.debian.org
    try:
        changelog = urllib2.urlopen('http://packages.debian.org/changelogs/pool'
                                    '/%s/%s/%s/%s_%s/changelog.txt'
                                    % (component, subdir, pkgname, pkgname,
                                       pkgversion))
    except urllib2.HTTPError, error:
        print >> sys.stderr, ('Unable to connect to packages.debian.org: %s'
                              % error)
        return None

    new_entries = ''
    changelog = Changelog(changelog.read())
    for block in changelog:
        if block.version > version:
            # see also Debian #561805
            new_entries += unicode(str(block).decode('utf-8'))

    return new_entries

if __name__ == '__main__':
	pkgs = []
	lp = Launchpad.login_anonymously('ubuntu-debian-delta', "edge")

	pkgs = get_package_list(lp, pkgs)
	for i in pkgs:
		ubuntu_upload_version = get_ubuntu_list(lp, i)
		debian_upload_version = get_debian_list(lp, i)
                if debian_newer(ubuntu_upload_version,debian_upload_version):
		  print "=== %-10s %-10s -> %-10s ===" %(i, ubuntu_upload_version, debian_upload_version)
                  print "Debian changes newer than ubuntu version:\n"
                  print getDebianChangelog(get_debian_package(lp,i),ubuntu_upload_version)
